/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.4 Revision 1.128
1# Copyright 2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.4 2007/12/22 16:28:59 caleb Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.128 2012/05/07 21:28:01 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Caleb Tennis <caleb@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: 8# @BLURB: Eclass for Qt4 split ebuilds.
9# Eclass for Qt4
10# @DESCRIPTION: 9# @DESCRIPTION:
11# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
12 11
13inherit eutils multilib toolchain-funcs flag-o-matic 12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
14 16
15IUSE="${IUSE} debug" 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
16 18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="virtual/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
56RDEPEND="
57 !<x11-libs/qt-assistant-${PV}
58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
61 !<x11-libs/qt-core-${PV}
62 !>x11-libs/qt-core-${PV}-r9999
63 !<x11-libs/qt-dbus-${PV}
64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
67 !<x11-libs/qt-demo-${PV}
68 !>x11-libs/qt-demo-${PV}-r9999
69 !<x11-libs/qt-gui-${PV}
70 !>x11-libs/qt-gui-${PV}-r9999
71 !<x11-libs/qt-multimedia-${PV}
72 !>x11-libs/qt-multimedia-${PV}-r9999
73 !<x11-libs/qt-opengl-${PV}
74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
77 !<x11-libs/qt-phonon-${PV}
78 !>x11-libs/qt-phonon-${PV}-r9999
79 !<x11-libs/qt-qt3support-${PV}
80 !>x11-libs/qt-qt3support-${PV}-r9999
81 !<x11-libs/qt-script-${PV}
82 !>x11-libs/qt-script-${PV}-r9999
83 !<x11-libs/qt-sql-${PV}
84 !>x11-libs/qt-sql-${PV}-r9999
85 !<x11-libs/qt-svg-${PV}
86 !>x11-libs/qt-svg-${PV}-r9999
87 !<x11-libs/qt-test-${PV}
88 !>x11-libs/qt-test-${PV}-r9999
89 !<x11-libs/qt-webkit-${PV}
90 !>x11-libs/qt-webkit-${PV}-r9999
91 !<x11-libs/qt-xmlpatterns-${PV}
92 !>x11-libs/qt-xmlpatterns-${PV}-r9999
93"
94
95S=${WORKDIR}/${MY_P}
96
97# @FUNCTION: qt4-build_pkg_setup
98# @DESCRIPTION:
99# Sets up PATH and LD_LIBRARY_PATH.
17qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
102
103 # Protect users by not allowing downgrades between releases
104 # Downgrading revisions within the same release should be allowed
105 if has_version '>'${CATEGORY}/${P}-r9999; then
106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
108 eerror "Sanity check to keep you from breaking your system:"
109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
111 die "aborting to save your system"
112 else
113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
114 fi
115 fi
116
117 if [[ ${PN} == qt-webkit ]]; then
118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
126 fi
127 eshopts_pop
128 fi
129
130 PATH="${S}/bin${PATH:+:}${PATH}"
131 if [[ ${CHOST} != *-darwin* ]]; then
132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
133 else
134 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
135 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
136 # platform detection. Note: needs to come before any directories to
137 # avoid extract failure.
138 [[ ${CHOST} == *-apple-darwin* ]] && \
139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
140 ${QT4_EXTRACT_DIRECTORIES}"
141 fi
142
143 if ! version_is_at_least 4.1 $(gcc-version); then
144 ewarn "Using a GCC version lower than 4.1 is not supported."
145 fi
146}
147
148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
149# @DESCRIPTION:
150# Arguments for build_target_directories. Takes the directories in which the
151# code should be compiled. This is a space-separated list.
152
153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
154# @DESCRIPTION:
155# Space-separated list including the directories that will be extracted from
156# Qt tarball.
157
158# @FUNCTION: qt4-build_src_unpack
159# @DESCRIPTION:
160# Unpacks the sources.
161qt4-build_src_unpack() {
162 setqtenv
163
164 case ${QT4_BUILD_TYPE} in
165 live)
166 git-2_src_unpack
167 ;;
168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
174 targets+="${MY_P}/${target} "
175 done
176
177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
179 eend $? || die "failed to unpack"
180 ;;
181 esac
182}
183
184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
186# @DESCRIPTION:
187# PATCHES array variable containing all various patches to be applied.
188# This variable is expected to be defined in global scope of ebuild.
189# Make sure to specify the full path. This variable is utilised in
190# src_unpack/src_prepare phase, based on EAPI.
191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
196
197# @FUNCTION: qt4-build_src_prepare
198# @DESCRIPTION:
199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
201qt4-build_src_prepare() {
202 setqtenv
203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
215
216 if use aqua; then
217 # provide a proper macx-g++-64
218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
219
220 sed -e '/^CONFIG/s:app_bundle::' \
221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
223 fi
224
225 if [[ ${PN} != qt-core ]]; then
226 skip_qmake_build
227 skip_project_generation
228 symlink_binaries_to_buildtree
229 fi
230
231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
234 replace-flags -O[23] -O1
235 fi
236
237 # Bug 178652
238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
240 append-flags -fno-gcse
241 fi
242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
254 # Unsupported old gcc versions - hardened needs this :(
255 if [[ $(gcc-major-version) -lt 4 ]]; then
256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
257 append-cxxflags -fno-stack-protector
258 # Bug 253127
259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
260 -i mkspecs/common/g++.conf || die
261 fi
262
263 # Bug 261632
264 if use ppc64; then
265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
266 append-flags -mminimal-toc
267 fi
268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 if ! version_is_at_least 4.8; then
287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
289 fi
290
291 # Bug 172219
292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
293
294 if [[ ${CHOST} == *-darwin* ]]; then
295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
311 -e "s:-arch\s\w*::g" \
312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
314
315 # Fix configure's -arch settings that appear in qmake/Makefile and also
316 # fix arch handling (automagically duplicates our -arch arg and breaks
317 # pch). Additionally disable Xarch support.
318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
322 sed \
323 -e "s:-arch i386::" \
324 -e "s:-arch ppc::" \
325 -e "s:-arch x86_64::" \
326 -e "s:-arch ppc64::" \
327 -e "s:-arch \$i::" \
328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
330 -e "s:-Xarch_x86_64::g" \
331 -e "s:-Xarch_ppc64::g" \
332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
334
335 # On Snow Leopard don't fall back to 10.5 deployment target.
336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
341 fi
342 fi
343
344 # this one is needed for all systems with a separate -liconv, apart from
345 # Darwin, for which the sources already cater for -liconv
346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
348 -i config.tests/unix/iconv/iconv.pro \
349 || die "sed iconv.pro failed"
350 fi
351
352 # we need some patches for Solaris
353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
355 # use GCC over SunStudio
356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
357 # do not flirt with non-Prefix stuff, we're quite possessive
358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
360
361 base_src_prepare
362}
363
364# @FUNCTION: qt4-build_src_configure
365# @DESCRIPTION:
366# Default configure phase
367qt4-build_src_configure() {
368 setqtenv
369
370 local conf="
371 -prefix ${QTPREFIXDIR}
372 -bindir ${QTBINDIR}
373 -libdir ${QTLIBDIR}
374 -docdir ${QTDOCDIR}
375 -headerdir ${QTHEADERDIR}
376 -plugindir ${QTPLUGINDIR}
377 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
378 -datadir ${QTDATADIR}
379 -translationdir ${QTTRANSDIR}
380 -sysconfdir ${QTSYSCONFDIR}
381 -examplesdir ${QTEXAMPLESDIR}
382 -demosdir ${QTDEMOSDIR}
383 -opensource -confirm-license
384 -shared -fast -largefile -stl -verbose
385 -nomake examples -nomake demos"
386
387 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
388 # $(tc-arch). Therefore we convert it to supported values.
389 case "$(tc-arch)" in
390 amd64|x64-*) conf+=" -arch x86_64" ;;
391 ppc-macos) conf+=" -arch ppc" ;;
392 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
393 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
394 x86-macos) conf+=" -arch x86" ;;
395 x86|x86-*) conf+=" -arch i386" ;;
396 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
397 hppa|sh) conf+=" -arch generic" ;;
398 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
399 esac
400
401 conf+=" -platform $(qt_mkspecs_dir)"
402
403 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
404
405 # debug/release
406 if use debug; then
407 conf+=" -debug"
408 else
409 conf+=" -release"
410 fi
411 conf+=" -no-separate-debug-info"
412
413 # exceptions USE flag
414 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
415
416 # disable RPATH on Qt >= 4.8 (bug 380415)
417 version_is_at_least 4.8 && conf+=" -no-rpath"
418
419 # precompiled headers don't work on hardened, where the flag is masked
420 conf+=" $(qt_use pch)"
421
422 # -reduce-relocations
423 # This flag seems to introduce major breakage to applications,
424 # mostly to be seen as a core dump with the message "QPixmap: Must
425 # construct a QApplication before a QPaintDevice" on Solaris.
426 # -- Daniel Vergien
427 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
428
429 # this one is needed for all systems with a separate -liconv, apart from
430 # Darwin, for which the sources already cater for -liconv
431 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
432 conf+=" -liconv"
433 fi
434
435 if use_if_iuse glib; then
436 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
437 # avoid the -pthread argument
438 conf+=" ${glibflags//-pthread}"
439 unset glibflags
440 fi
441
442 if use_if_iuse qpa; then
443 echo
444 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
445 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
446 ewarn "disable it before reporting any bugs related to this useflag."
447 echo
448 conf+=" -qpa"
449 fi
450
451 if use aqua; then
452 # On (snow) leopard use the new (frameworked) cocoa code.
453 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
454 conf+=" -cocoa -framework"
455 # We need the source's headers, not the installed ones.
456 conf+=" -I${S}/include"
457 # Add hint for the framework location.
458 conf+=" -F${QTLIBDIR}"
459
460 # We are crazy and build cocoa + qt3support :-)
461 if use qt3support; then
462 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
463 -i configure || die
464 fi
465 else
466 conf+=" -no-framework"
467 fi
468 else
469 # freetype2 include dir is non-standard, thus pass it to configure
470 conf+=" $(pkg-config --cflags-only-I freetype2)"
471 fi
472
473 conf+=" ${myconf}"
474 myconf=
475
476 echo ./configure ${conf}
477 ./configure ${conf} || die "./configure failed"
478
479 prepare_directories ${QT4_TARGET_DIRECTORIES}
480}
481
482# @FUNCTION: qt4-build_src_compile
483# @DESCRIPTION:
484# Actual compile phase
485qt4-build_src_compile() {
486 setqtenv
487
488 build_directories ${QT4_TARGET_DIRECTORIES}
489}
490
491# @FUNCTION: qt4-build_src_test
492# @DESCRIPTION:
493# Runs tests only in target directories.
494qt4-build_src_test() {
495 # QtMultimedia does not have any test suite (bug #332299)
496 [[ ${PN} == qt-multimedia ]] && return
497
498 for dir in ${QT4_TARGET_DIRECTORIES}; do
499 emake -j1 check -C ${dir}
500 done
501}
502
503# @FUNCTION: fix_includes
504# @DESCRIPTION:
505# For MacOS X we need to add some symlinks when frameworks are
506# being used, to avoid complications with some more or less stupid packages.
507fix_includes() {
508 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
509 local frw dest f h rdir
510 # Some packages tend to include <Qt/...>
511 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
512
513 # Fake normal headers when frameworks are installed... eases life later
514 # on, make sure we use relative links though, as some ebuilds assume
515 # these dirs exist in src_install to add additional files
516 f=${QTHEADERDIR}
517 h=${QTLIBDIR}
518 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
519 f=${f#*/}
520 h=${h#*/}
521 done
522 rdir=${h}
523 f="../"
524 while [[ ${h} == */* ]] ; do
525 f="${f}../"
526 h=${h#*/}
527 done
528 rdir="${f}${rdir}"
529
530 for frw in "${D}${QTLIBDIR}"/*.framework; do
531 [[ -e "${frw}"/Headers ]] || continue
532 f=$(basename ${frw})
533 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
534 dosym "${rdir}"/${f}/Headers "${dest}"
535
536 # Link normal headers as well.
537 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
538 h=$(basename ${hdr})
539 dosym "../${rdir}"/${f}/Headers/${h} \
540 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
541 done
542 done
543 fi
544}
545
546# @FUNCTION: qt4-build_src_install
547# @DESCRIPTION:
548# Perform the actual installation including some library fixes.
549qt4-build_src_install() {
550 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
551 setqtenv
552
553 install_directories ${QT4_TARGET_DIRECTORIES}
554 install_qconfigs
555 fix_library_files
556 fix_includes
557
558 # remove .la files since we are building only shared Qt libraries
559 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
560}
561
562# @FUNCTION: setqtenv
563# @INTERNAL
564setqtenv() {
18 # Set up installation directories 565 # Set up installation directories
19 566 QTPREFIXDIR=${EPREFIX}/usr
20 QTBASEDIR=/usr/$(get_libdir)/qt4 567 QTBINDIR=${EPREFIX}/usr/bin
21 QTPREFIXDIR=/usr
22 QTBINDIR=/usr/bin
23 QTLIBDIR=/usr/$(get_libdir)/qt4 568 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
24 QTPCDIR=/usr/$(get_libdir)/pkgconfig 569 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
25 QTDATADIR=/usr/share/qt4 570 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
26 QTDOCDIR=/usr/share/doc/${PF} 571 QTHEADERDIR=${EPREFIX}/usr/include/qt4
27 QTHEADERDIR=/usr/include/qt4
28 QTPLUGINDIR=${QTLIBDIR}/plugins 572 QTPLUGINDIR=${QTLIBDIR}/plugins
29 QTSYSCONFDIR=/etc/qt4 573 QTIMPORTDIR=${QTLIBDIR}/imports
574 QTDATADIR=${EPREFIX}/usr/share/qt4
30 QTTRANSDIR=${QTDATADIR}/translations 575 QTTRANSDIR=${QTDATADIR}/translations
576 QTSYSCONFDIR=${EPREFIX}/etc/qt4
31 QTEXAMPLESDIR=${QTDATADIR}/examples 577 QTEXAMPLESDIR=${QTDATADIR}/examples
32 QTDEMOSDIR=${QTDATADIR}/demos 578 QTDEMOSDIR=${QTDATADIR}/demos
579 QMAKE_LIBDIR_QT=${QTLIBDIR}
580 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
33 581
34 PLATFORM=$(qt_mkspecs_dir) 582 PLATFORM=$(qt_mkspecs_dir)
35 583
36 PATH="${S}/bin:${PATH}" 584 unset QMAKESPEC
37 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}"
38} 585}
39 586
40qt4-build_src_unpack() { 587# @FUNCTION: prepare_directories
41 unpack ${A} 588# @USAGE: < directories >
42 cd "${S}" 589# @INTERNAL
43 590# @DESCRIPTION:
44 # Don't let the user go too overboard with flags. If you really want to, uncomment 591# Generates Makefiles for the given list of directories.
45 # out the line below and give 'er a whirl. 592prepare_directories() {
46 strip-flags 593 for x in "$@"; do
47 replace-flags -O3 -O2 594 pushd "${S}"/${x} >/dev/null || die
48 595 einfo "Running qmake in: ${x}"
49 if [[ $( gcc-fullversion ) == "3.4.6" && gcc-specs-ssp ]] ; then 596 # avoid running over the maximum argument number, bug #299810
50 ewarn "Appending -fno-stack-protector to CFLAGS/CXXFLAGS" 597 {
51 append-flags -fno-stack-protector 598 echo "${S}"/mkspecs/common/*.conf
52 fi 599 find "${S}" -name '*.pr[io]'
600 } | xargs sed -i \
601 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
602 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
603 || die
604 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
605 popd >/dev/null || die
606 done
53} 607}
54 608
55qt4-build_src_install() {
56 install_directories "${QT4_TARGET_DIRECTORIES}"
57 fix_library_files
58}
59 609
60standard_configure_options() { 610# @FUNCTION: build_directories
61 local myconf="" 611# @USAGE: < directories >
62 612# @INTERNAL
63 [ $(get_libdir) != "lib" ] && myconf="${myconf} -L/usr/$(get_libdir)" 613# @DESCRIPTION:
64 614# Compiles the code in the given list of directories.
65 # Disable visibility explicitly if gcc version isn't 4
66 if [[ "$(gcc-major-version)" != "4" ]]; then
67 myconf="${myconf} -no-reduce-exports"
68 fi
69
70 use debug && myconf="${myconf} -debug -no-separate-debug-info" || myconf="${myconf} -release -no-separate-debug-info"
71
72 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath\
73 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR} -datadir ${QTDATADIR} \
74 -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR} -plugindir ${QTPLUGINDIR} \
75 -sysconfdir ${QTSYSCONFDIR} -translationdir ${QTTRANSDIR} \
76 -examplesdir ${QTEXAMPLESDIR} -demosdir ${QTDEMOSDIR}"
77
78 myconf="${myconf} -silent -fast -reduce-relocations -nomake examples -nomake demos"
79
80 echo "${myconf}"
81}
82
83build_target_directories() {
84 build_directories "${QT4_TARGET_DIRECTORIES}"
85}
86
87build_directories() { 615build_directories() {
88 local dirs="$@"
89 for x in ${dirs}; do 616 for x in "$@"; do
90 cd "${S}"/${x} 617 pushd "${S}"/${x} >/dev/null || die
91 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" && emake || die 618 emake CC="$(tc-getCC)" \
619 CXX="$(tc-getCXX)" \
620 LINK="$(tc-getCXX)" || die "emake failed"
621 popd >/dev/null || die
92 done 622 done
93} 623}
94 624
625# @FUNCTION: install_directories
626# @USAGE: < directories >
627# @INTERNAL
628# @DESCRIPTION:
629# Runs emake install in the given directories, which are separated by spaces.
95install_directories() { 630install_directories() {
96 local dirs="$@"
97 for x in ${dirs}; do 631 for x in "$@"; do
98 cd "${S}"/${x} 632 pushd "${S}"/${x} >/dev/null || die
99 emake INSTALL_ROOT="${D}" install || die 633 emake INSTALL_ROOT="${D}" install || die "emake install failed"
634 popd >/dev/null || die
100 done 635 done
101} 636}
102 637
103qconfig_add_option() { 638# @ECLASS-VARIABLE: QCONFIG_ADD
104 local option=$1 639# @DESCRIPTION:
105 qconfig_remove_option $1 640# List options that need to be added to QT_CONFIG in qconfig.pri
106 sed -i -e "s:QT_CONFIG +=:QT_CONFIG += ${option}:g" /usr/share/qt4/mkspecs/qconfig.pri 641: ${QCONFIG_ADD:=}
107}
108 642
109qconfig_remove_option() { 643# @ECLASS-VARIABLE: QCONFIG_REMOVE
110 local option=$1 644# @DESCRIPTION:
111 sed -i -e "s: ${option}::g" /usr/share/qt4/mkspecs/qconfig.pri 645# List options that need to be removed from QT_CONFIG in qconfig.pri
112} 646: ${QCONFIG_REMOVE:=}
113 647
648# @ECLASS-VARIABLE: QCONFIG_DEFINE
649# @DESCRIPTION:
650# List variables that should be defined at the top of QtCore/qconfig.h
651: ${QCONFIG_DEFINE:=}
652
653# @FUNCTION: install_qconfigs
654# @INTERNAL
655# @DESCRIPTION:
656# Install gentoo-specific mkspecs configurations.
657install_qconfigs() {
658 local x
659 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
660 for x in QCONFIG_ADD QCONFIG_REMOVE; do
661 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
662 done
663 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
664 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
665 fi
666
667 if [[ -n ${QCONFIG_DEFINE} ]]; then
668 for x in ${QCONFIG_DEFINE}; do
669 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
670 done
671 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
672 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
673 fi
674}
675
676# @FUNCTION: generate_qconfigs
677# @INTERNAL
678# @DESCRIPTION:
679# Generates gentoo-specific qconfig.{h,pri}.
680generate_qconfigs() {
681 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
682 local x qconfig_add qconfig_remove qconfig_new
683 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
684 [[ -f ${x} ]] || continue
685 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
686 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
687 done
688
689 # these error checks do not use die because dying in pkg_post{inst,rm}
690 # just makes things worse.
691 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
692 # start with the qconfig.pri that qt-core installed
693 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
694 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
695 eerror "cp qconfig failed."
696 return 1
697 fi
698
699 # generate list of QT_CONFIG entries from the existing list
700 # including qconfig_add and excluding qconfig_remove
701 for x in $(sed -n 's/^QT_CONFIG +=//p' \
702 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
703 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
704 done
705
706 # replace the existing QT_CONFIG list with qconfig_new
707 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
708 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
709 eerror "Sed for QT_CONFIG failed"
710 return 1
711 fi
712
713 # create Gentoo/qconfig.h
714 if [[ ! -e ${ROOT}${QTHEADERDIR}/Gentoo ]]; then
715 if ! mkdir -p "${ROOT}${QTHEADERDIR}"/Gentoo; then
716 eerror "mkdir ${QTHEADERDIR}/Gentoo failed"
717 return 1
718 fi
719 fi
720 : > "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-qconfig.h
721 for x in "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-*-qconfig.h; do
722 [[ -f ${x} ]] || continue
723 cat "${x}" >> "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-qconfig.h
724 done
725 else
726 rm -f "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri
727 rm -f "${ROOT}${QTHEADERDIR}"/Gentoo/gentoo-qconfig.h
728 rmdir "${ROOT}${QTDATADIR}"/mkspecs \
729 "${ROOT}${QTDATADIR}" \
730 "${ROOT}${QTHEADERDIR}"/Gentoo \
731 "${ROOT}${QTHEADERDIR}" 2>/dev/null
732 fi
733 fi
734}
735
736# @FUNCTION: qt4-build_pkg_postrm
737# @DESCRIPTION:
738# Regenerate configuration when the package is completely removed.
739qt4-build_pkg_postrm() {
740 generate_qconfigs
741}
742
743# @FUNCTION: qt4-build_pkg_postinst
744# @DESCRIPTION:
745# Regenerate configuration, plus throw a message about possible
746# breakages and proposed solutions.
747qt4-build_pkg_postinst() {
748 generate_qconfigs
749}
750
751# @FUNCTION: skip_qmake_build
752# @INTERNAL
753# @DESCRIPTION:
754# Patches configure to skip qmake compilation, as it's already installed by qt-core.
114skip_qmake_build_patch() { 755skip_qmake_build() {
115 # Don't need to build qmake, as it's already installed from qmake-core
116 sed -i -e "s:if true:if false:g" "${S}"/configure 756 sed -i -e "s:if true:if false:g" "${S}"/configure || die
117} 757}
118 758
119skip_project_generation_patch() { 759# @FUNCTION: skip_project_generation
760# @INTERNAL
761# @DESCRIPTION:
120 # Exit the script early by throwing in an exit before all of the .pro files are scanned 762# Exit the script early by throwing in an exit before all of the .pro files are scanned.
763skip_project_generation() {
121 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure 764 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
122} 765}
123 766
767# @FUNCTION: symlink_binaries_to_buildtree
768# @INTERNAL
769# @DESCRIPTION:
770# Symlinks generated binaries to buildtree, so they can be used during compilation time.
124install_binaries_to_buildtree() 771symlink_binaries_to_buildtree() {
125{ 772 for bin in qmake moc uic rcc; do
126 cp ${QTBINDIR}/qmake ${S}/bin 773 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
127 cp ${QTBINDIR}/moc ${S}/bin 774 done
128 cp ${QTBINDIR}/uic ${S}/bin
129 cp ${QTBINDIR}/rcc ${S}/bin
130} 775}
131 776
777# @FUNCTION: fix_library_files
778# @INTERNAL
779# @DESCRIPTION:
780# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
781# moves the *.pc files into the pkgconfig directory.
132fix_library_files() { 782fix_library_files() {
133 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" "${D}"/${QTLIBDIR}/*.la 783 local libfile
134 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" "${D}"/${QTLIBDIR}/*.prl 784 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
135 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" "${D}"/${QTLIBDIR}/pkgconfig/*.pc 785 if [[ -e ${libfile} ]]; then
786 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
787 fi
788 done
136 789
137 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 790 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
138 sed -i -e "s:${S}/bin:${QTBINDIR}:g" "${D}"/${QTLIBDIR}/pkgconfig/*.pc 791 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
792 if [[ -e ${libfile} ]]; then
793 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
139 794
140 # Move .pc files into the pkgconfig directory 795 # Move .pc files into the pkgconfig directory
141 dodir ${QTPCDIR} 796 dodir ${QTPCDIR#${EPREFIX}}
142 mv "${D}"/${QTLIBDIR}/pkgconfig/*.pc "${D}"/${QTPCDIR} 797 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
143} 798 fi
799 done
144 800
801 # Don't install an empty directory
802 rmdir "${D}"/${QTLIBDIR}/pkgconfig
803}
804
805# @FUNCTION: qt_use
806# @USAGE: < flag > [ feature ] [ enableval ]
807# @DESCRIPTION:
808# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
809# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
810# will be used for that. If [enableval] is not specified, it omits the
811# "-${enableval}" part.
145qt_use() { 812qt_use() {
146 local flag="$1" 813 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
147 local feature="$1"
148 local enableval=
149
150 [[ -n $2 ]] && feature=$2
151 [[ -n $3 ]] && enableval="-$3"
152
153 useq $flag && echo "${enableval}-${feature}" || echo "-no-${feature}"
154 return 0
155} 814}
156 815
816# @FUNCTION: qt_mkspecs_dir
817# @RETURN: the specs-directory w/o path
818# @DESCRIPTION:
819# Allows us to define which mkspecs dir we want to use.
157qt_mkspecs_dir() { 820qt_mkspecs_dir() {
158 # Allows us to define which mkspecs dir we want to use. 821 local spec=
159 local spec
160 822
161 case ${CHOST} in 823 case "${CHOST}" in
162 *-freebsd*|*-dragonfly*) 824 *-freebsd*|*-dragonfly*)
163 spec="freebsd" ;; 825 spec=freebsd ;;
164 *-openbsd*) 826 *-openbsd*)
165 spec="openbsd" ;; 827 spec=openbsd ;;
166 *-netbsd*) 828 *-netbsd*)
167 spec="netbsd" ;; 829 spec=netbsd ;;
168 *-darwin*) 830 *-darwin*)
169 spec="darwin" ;; 831 if use aqua; then
170 *-linux-*|*-linux) 832 # mac with carbon/cocoa
171 spec="linux" ;; 833 spec=macx
172 *) 834 else
173 die "Unknown CHOST, no platform choosed." 835 # darwin/mac with x11
174 esac 836 spec=darwin
837 fi
838 ;;
839 *-solaris*)
840 spec=solaris ;;
841 *-linux-*|*-linux)
842 spec=linux ;;
843 *)
844 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
845 esac
175 846
176 CXX=$(tc-getCXX) 847 case "$(tc-getCXX)" in
177 if [[ ${CXX/g++/} != ${CXX} ]]; then 848 *g++*)
178 spec="${spec}-g++" 849 spec+=-g++ ;;
179 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 850 *icpc*)
180 spec="${spec}-icc" 851 spec+=-icc ;;
181 else 852 *)
182 die "Unknown compiler ${CXX}." 853 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
183 fi 854 esac
184 855
856 # Add -64 for 64bit profiles
857 if use x64-freebsd ||
858 use amd64-linux ||
859 use x64-macos ||
860 use x64-solaris ||
861 use sparc64-solaris
862 then
863 spec+=-64
864 fi
865
185 echo "${spec}" 866 echo "${spec}"
186} 867}
187 868
188EXPORT_FUNCTIONS pkg_setup src_unpack src_install 869# @FUNCTION: qt_assistant_cleanup
870# @INTERNAL
871# @DESCRIPTION:
872# Tries to clean up tools.pro for qt-assistant ebuilds.
873# Meant to be called in src_prepare().
874# Since Qt 4.7.4 this function is a no-op.
875qt_assistant_cleanup() {
876 # apply patching to qt-assistant ebuilds only
877 [[ ${PN} != qt-assistant ]] && return
878
879 # no longer needed for 4.7.4 and later
880 version_is_at_least 4.7.4 && return
881
882 # different versions (and branches...) may need different handling,
883 # add a case if you need special handling
884 case "${MY_PV_EXTRA}" in
885 *kde-qt*)
886 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
887 -e "/mac/,/^embedded.*makeqpf$/d" \
888 -i tools/tools.pro || die "patching tools.pro failed"
889 ;;
890 *)
891 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
892 -e "/mac/,/^embedded.*makeqpf$/d" \
893 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
894 -i tools/tools.pro || die "patching tools.pro failed"
895 ;;
896 esac
897}
898
899# @FUNCTION: qt_nolibx11
900# @INTERNAL
901# @DESCRIPTION:
902# Ignore X11 tests for packages that don't need X libraries installed.
903qt_nolibx11() {
904 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
905 die "x11 check sed failed"
906}
907
908EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.4  
changed lines
  Added in v.1.128

  ViewVC Help
Powered by ViewVC 1.1.20